/*
    Data block printing functions.
    Copyright (C) 2015  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */


/***************************************************************************/
/* include vari */

#include <stdio.h>

#include "block.h"				// functions prototypes

/***************************************************************************/
/* define interni alla libreria */

#define MAX_BYTES_PER_LINE	16

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* costanti interne alla libreria */

/***************************************************************************/
/* variabili interne alla libreria */

/***************************************************************************/
/* funzioni interne alla libreria */

static void PrintDataLine(unsigned char *Buffer,unsigned long int Addr,int Len);
  /* Stampa a video una riga di Len byte. */

/***************************************************************************/
/* funzioni */

static void PrintDataLine(unsigned char *Buffer,unsigned long int Addr,int Len)
{
  /* Stampa a video una riga di Len byte. */



  int	i;



  printf("%08lx  ",Addr);			// indirizzo a inizio riga

  // riempie la riga col formato esadecimale
  for(i=0;i<Len;i++)
    printf("%02x ",(unsigned int)Buffer[i]);
  for(;i<MAX_BYTES_PER_LINE;i++)
    printf("   ");

  // a fine riga mette i formato ASCII
  putchar(' ');
  for(i=0;i<Len;i++)
    if((Buffer[i] >= 0x20) && (Buffer[i] <= 0x7f))	// se e' stampabile
      putchar(Buffer[i]);				// ASCII char
    else
      putchar('.');					// solo un puntino
  putchar('\n');				// chiude la riga
  return;					// termina
}



void PrintDataBlock(unsigned char *Buffer,unsigned long int Addr,int BlockSize)
{
  /* Stampa a video un data block prelevato dal device. */



  int	Len;					// lunghezza di una riga



  while(BlockSize)
  {
    if(BlockSize >= MAX_BYTES_PER_LINE)		// determina la dim. della riga
      Len=MAX_BYTES_PER_LINE;
    else
      Len=BlockSize;
    PrintDataLine(Buffer,Addr,Len);		// stampa una riga
    Addr+=Len;					// indirizzo riga successiva
    Buffer+=Len;				// salta i byte stampati
    BlockSize-=Len;				// scala la dim. del blocco
  }
  return;					// termina
}

/* $Source$ */

