/*
    AT24C02A family driver implementation.
    Copyright (C) 2011 2012 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __AT24C02A_H
#define __AT24C02A_H	1


#include "datatype.h"				// special data types

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

#ifdef __AT24C02A_C

const char		AT24C02A_LinkMap[]=
					"D0 ----> D/c\n"
					"D1 ----> R/w\n"
					"D2 ----> E\n"
					"D3 ---   nc\n"
					"D4 <---> D4\n"
					"D5 <---> D5\n"
					"D6 <---> D6\n"
					"D7 <---> D7\n";

#else

extern const char	AT24C02A_LinkMap[];

#endif

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int AT24C02A_InitBus(void *Chipset,int argc,char **argv);
  /* Imposta la direzione e lo stato iniziale delle linee del bus. */

int AT24C02A_TextWrite(Addr_t Address,const char *Text,int Len);
  /* Scrive una stringa di testo all'indirizzo indicato. */

int AT24C02A_TextRead(Addr_t Address,char *Text,int Len);
  /* Legge una stringa di Len char dall'indirizzo indicato. */

int AT24C02A_BlockWrite(Addr_t Address,const Byte_t *Data,int Len);
  /* Scrive un blocco dati all'indirizzo indicato. */

int AT24C02A_BlockRead(Addr_t Address,Byte_t *Buf,int Len);
  /* Legge un blocco dati dall'indirizzo indicato. */

/***************************************************************************/
#endif

/* $Source$ */

