/*
    Atmel AVR microcontrollers support.
    Copyright (C) 2012  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __ATMEL_H
#define __ATMEL_H	1


/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

#ifdef __ATMEL_C

const char		ATMEL_LinkMap[]=
					"D0 ----> D/c\n"
					"D1 ----> R/w\n"
					"D2 ----> E\n"
					"D3 ---   nc\n"
					"D4 <---> D4\n"
					"D5 <---> D5\n"
					"D6 <---> D6\n"
					"D7 <---> D7\n";

#else

extern const char	ATMEL_LinkMap[];

#endif

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int ATMEL_InitBus(void *Chipset,int argc,char **argv);
  /* Imposta la direzione e lo stato iniziale delle linee del bus. */

int ATMEL_FlashWrite(unsigned long int Address,unsigned char Data[],int Len);
  /* Scrive la FLASH del micro mostrandola come se fosse un solo blocco,
     la suddivisione in pagine viene fatta internamente. */

int ATMEL_FlashRead(unsigned long int Address,unsigned char *Buf,int Len);
  /* Legge la FLASH del micro mostrandola come se fosse un solo blocco,
     la suddivisione in pagine viene fatta internamente. */

int ATMEL_EepromWrite(unsigned long int Address,unsigned char Data[],int Len);
  /* Scrive la EEPROM del micro mostrandola come se fosse un solo blocco,
     la suddivisione in pagine viene fatta internamente. */

int ATMEL_EepromRead(unsigned long int Address,unsigned char *Buf,int Len);
  /* Legge la EEPROM del micro mostrandola come se fosse un solo blocco,
     la suddivisione in pagine viene fatta internamente. */

/***************************************************************************/
#endif

/* $Source$ */

