/*
    Supported chipset list.
    Copyright (C) 2011 2014 2015  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __CHIPSET_H
#define __CHIPSET_H	1


#include "drv_type.h"				// driver data type

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

const DrvInt_t *ChipsetSearch(const char *DrvName);
  /* Cerca un driver con il nome indicato e ritorna un puntatore al driver
     stesso, ritorna NULL se non esiste un driver col nome indicato.
     Chiamata con DrvName=NULL ritorna il primo chipset della lista. */

int ChipsetMaxBlock(void);
  /* Ritorna la dimensione del singolo blocco piu' grande tra tutti i
     chipset supportati. */

int ChipsetMaxSize(void);
  /* Ritorna la dimensione totale piu' grande tra tutti i chipset supportati. */

/***************************************************************************/
#endif

/* $Source$ */

