/*
    Driver data type definition.
    Copyright (C) 2011 2014 2015 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __DRV_TYPE_H
#define __DRV_TYPE_H	1


#include "datatype.h"				// special data types

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

#define CHIP_SET(Name,File,Map,Init,cw,dw,dr,bw,br,bs,bn)	{Name,File,Map,Init,cw,dw,dr,bw,br,bs,bn}
#define END_OF_LIST()	{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0}
#define IsEndOfList(pt)	(pt->BusInit == NULL)

/***************************************************************************/
/* strutture pubbliche */

typedef int (*BusInit_t)   (void *Chipset,int argc,char **argv);
typedef int (*CmdSend_t)   (		 const Byte_t *Cmd,	int Len);
typedef int (*CharWrite_t) (Addr_t Addr, const char *Text,	int Len);
typedef int (*CharRead_t)  (Addr_t Addr, char *Text,		int Len);
typedef int (*BlockWrite_t)(Addr_t Addr, const Byte_t *Data,	int Len);
typedef int (*BlockRead_t) (Addr_t Addr, Byte_t *Data,		int Len);



typedef struct
{
  const char	*DrvName;	// nome del driver
  const char	*DrvFile;	// nome del file che implementa il driver
  const char	*LinkMap;	// ascii-art dei collegamenti

  BusInit_t	BusInit;	// bus init
  CmdSend_t	CmdSend;
  CharWrite_t	CharWrite;
  CharRead_t	CharRead;
  BlockWrite_t	BlockWrite;
  BlockRead_t	BlockRead;

  int		BlockSize;	// single block size o lunghezza di una riga
  int		BlocksNum;	// numero totale di blocchi o di righe
}DrvInt_t;

/***************************************************************************/
/* costanti pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

/***************************************************************************/
#endif

/* $Source$ */

