/*
    I2C bus implementation and handling functions.
    Copyright (C) 2010 2012 2016 2018  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __I2C_H
#define __I2C_H	1


/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int I2C_InitBus(unsigned long int PageSize,unsigned int AddressBits,
		unsigned char DevMask);
  /* Imposta la direzione e lo stato iniziale delle linee del bus,
     definisce il numero di bit di indirizzo e l'ID per l'indirizzamento
     del device sul bus. */

int I2C_WriteByte(unsigned long int Address,unsigned char Data);
  /* Scrive un byte all'indirizzo indicato, ritorna 0 in caso di successo. */

int I2C_ReadByte(unsigned long int Address,unsigned char *Data);
  /* Legge un byte dall'indirizzo indicato, ritorna 0 in caso di successo. */

int I2C_WritePage(unsigned long int Address,const unsigned char *Data);
  /* Scrive una pagina all'indirizzo indicato, ritorna 0 in caso di successo. */

int I2C_ReadPage(unsigned long int Address,unsigned char *Data);
  /* Legge una pagina dall'indirizzo indicato, ritorna 0 in caso di successo. */

/***************************************************************************/
#endif

/* $Source$ */

