/*
    Nokia LCD driver, this drivr supports different display controllers:
    S1G15D10, LDS176, PCF8833 re supported.
    Copyright (C) 2011  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __NOKIADRV_H
#define __NOKIADRV_H	1


/***************************************************************************/
/* define pubblici */

  // chipset supportati
#define S1G15D10	0
#define LDS176		1
#define PCF8833		2

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

#ifdef __NOKIADRV_C

#else

#endif

/***************************************************************************/
/* variabili pubbliche */

#ifdef __NOKIADRV_C

#else

#endif

/***************************************************************************/
/* funzioni pubbliche */

int NokiaLcd_InitBus(int ChipSet);
  /* Inizializza il bus di comunicazione col display controller e
     inizializza il display secondo il ChipSet selezionato. */

#ifndef __INIT_ONLY_FNCT

void NokiaLcd_SendCommand(unsigned char Cmd,int DataLen,unsigned char Data[]);
  /* Invia un byte comando seguito da un array di argomenti a display. */

void NokiaLcd_SetWindow(unsigned char x1,unsigned char y1,
			unsigned char x2,unsigned char y2);
  /* Imposta l'area accessibile in scrittura sul display. */

void NokiaLcd_SetContrast(unsigned char Contrast);
  /* Imposta il contrasto del display. */

void NokiaLcd_CopyFrame(unsigned char *Frame,int FrameLen);
  /* Invia un frame buffer al display driver cominciando dall'angolo in alto
     a destra del display. */

void NokiaLcd_PrintStr(char *Str);
  /* Stampa una stringa a video come se fosse un terminale testuale. */

#endif

/***************************************************************************/
#endif

/* $Source$ */

