/*
    Command line parser implementation.
    Copyright (C) 2011  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */


/***************************************************************************/
/* include vari */

#define __PARSER_C
#include "parser.h"				// functions prototypes

#include <stdio.h>
#include <unistd.h>
#include <string.h>

/***************************************************************************/
/* define interni alla libreria */

#define SEARCH_FOR_START	0	// cerca l'inizio dell'argomento
#define SEARCH_FOR_STOP		1	// cerca la fine dell'argomento
#define SEARCH_FOR_END_OF_QUOTE	2	// cerca la fine di una stringa fissa

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* costanti interne alla libreria */

/***************************************************************************/
/* variabili interne alla libreria */

/***************************************************************************/
/* funzioni interne alla libreria */

/***************************************************************************/
/* funzioni */

int ParseLine(char *LineCmd)
{
  /* Suddivide la linea di comando in argomenti e costruisce l'array Argv.
     Ritorna il numero di argomenti Argc. */
  
  

  int	i=0;
  int	Argc=0;				// numero argomenti trovati
  int	Mode=SEARCH_FOR_START;		// modo operativo
  char	Ending='\'';			// char di terminazione quota
  
  
  
  if(LineCmd[0] == '#')			// se e' una riga commentata
    return 0;				// termina senza argomenti
  if(!strlen(LineCmd))			// se e' una stringa vuota
    return 0;				// termina senza argomenti
  while(LineCmd[i]!=0x00)
  {
    switch(Mode)
    {
      case SEARCH_FOR_START:
        if((LineCmd[i]=='\'') || (LineCmd[i]=='"'))	// se inizia una quota
	{
	  Ending=LineCmd[i];		// imposta il terminatore
	  i++;				// salta l'apice
	  Argv[Argc++]=&LineCmd[i];	// inserisce il prossimo nella lista
	  Mode=SEARCH_FOR_END_OF_QUOTE;	// cerca la fine della quota
	}
	else
	{
	  if(LineCmd[i]!=' ')		// se non e' uno spazio
	  {
	    Argv[Argc++]=&LineCmd[i];	// inserisce il prossimo nella lista
	    Mode=SEARCH_FOR_STOP;	// cerca la fine della costante
	  }
	}
      break;
      case SEARCH_FOR_STOP:
	if(LineCmd[i]==' ')		// se e' uno spazio
	{
	  LineCmd[i]=0x00;		// termina l'argomento
	  Mode=SEARCH_FOR_START;	// cerca un nuovo inizio
	}
      break;
      case SEARCH_FOR_END_OF_QUOTE:
	if(LineCmd[i]==Ending)		// se e' un apice
	{
	  LineCmd[i]=0x00;		// termina l'argomento
	  Mode=SEARCH_FOR_START;	// cerca un nuovo inizio
	}
      break;
    }
    i++;				// prossimo char
  }
  return(Argc);				// termina
}

/* $Source$ */

