/*
    Low level I/O access functions.
    Copyright (C) 2008  Alessandro Accattini


 *****************************************************************************
 *
 *
 * $Header: /users/CVS/oled_linux/io.h,v 1.2 2010-02-03 13:22:49 akerue Exp $
 *
 *
 *
 * REVISION HISTORY:
 * $Log: io.h,v $
 * Revision 1.2  2010-02-03 13:22:49  akerue
 *
 * Ora il driver e' in grado di supportare tutte le revisioni dell'hardware,
 * basta avviarlo passandogli il parametro Hard=0|1|2.
 *
 * Revision 1.1.1.1  2009/10/01 14:49:33  akerue
 * oled linux driver
 *
 */

#ifndef __IO_H
#define __IO_H		1


#include <asm/arch/karo.h>
#include <asm/arch/pxa32x-regs.h>

/***************************************************************************/
/* define pubblici */

  /* hardware revision */
#define TRITON_REV_1	0
#define TRITON_REV_2	1
#define TRITON_REV_3	2


  /* assegnazione delle linee di controllo */
#define CS_LINE		53
#define DC_LINE		54

#define CLK_LINE	49
#define SDO_LINE	55

#define KEY2_LINE	44
#define KEY3_LINE	47

#define LED1_LINE	46
#define LED2_LINE	45
#define LED3_LINE	48

#define BOARD_POS_0	119
#define BOARD_POS_1	122
#define BOARD_POS_2	123
#define BOARD_POS_3	124
#define BOARD_POS_4	125
#define BOARD_POS_5	126

#define Set_OLED_CS(V)	V ? gpio_set_bit(CS_LINE) : gpio_clr_bit(CS_LINE)
#define Set_OLED_DC(V)	V ? gpio_set_bit(DC_LINE) : gpio_clr_bit(DC_LINE)
#define Set_OLED_NEN(V)	V ? gpio_set_bit(NEN_LINE) : gpio_clr_bit(NEN_LINE)
#define Set_OLED_RES(V)	V ? gpio_set_bit(RES_LINE) : gpio_clr_bit(RES_LINE)
#define Set_OLED_SEL(V)	V ? gpio_set_bit(SEL_LINE) : gpio_clr_bit(SEL_LINE)
#define Set_SPI_CLK(V)	V ? gpio_set_bit(CLK_LINE) : gpio_clr_bit(CLK_LINE)
#define Set_SPI_SDO(V)	V ? gpio_set_bit(SDO_LINE) : gpio_clr_bit(SDO_LINE)
#define Set_LED1(V)	V ? gpio_set_bit(LED1_LINE) : gpio_clr_bit(LED1_LINE)
#define Get_KEY1()	gpio_tst_bit(KEY1_LINE)
#define Get_KEY2()	gpio_tst_bit(KEY2_LINE)
#define Get_KEY3()	gpio_tst_bit(KEY3_LINE)
#define Get_SUSPEND()	gpio_tst_bit(SUSPEND_LINE)
#define EnableOled()	gpio_clr_bit(NEN_LINE)
#define DisableOled()	gpio_set_bit(NEN_LINE)

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

#ifdef __IO_C

#else

#endif

/***************************************************************************/
/* variabili pubbliche */

#ifdef __IO_C

int		NEN_LINE=50;
int		RES_LINE=52;
int		SEL_LINE=51;
int		SUSPEND_LINE=9;
int		KEY1_LINE=70;

#else

extern int	NEN_LINE;
extern int	RES_LINE;
extern int	SEL_LINE;
extern int	SUSPEND_LINE;
extern int	KEY1_LINE;

#endif

/***************************************************************************/
/* funzioni pubbliche */

int InitIO(int HardwareType);
  /* Inizializza le linee di I/O, ritorna 0 in caso di successo. */


#ifndef __INIT_ONLY_FNCT

unsigned int GetBoardPosition(void);
  /* Restituisce l'indirizzo della CPU letto dal BUS. */

void Set_LED2(int V);
  /* Accende/spegne il LED 2. */

void Set_LED3(int V);
  /* Accende/spegne il LED 3. */

#endif

/***************************************************************************/
#endif

/* $Source: /users/CVS/oled_linux/io.h,v $ */

