/*
    OLED display handling functions.
    Copyright (C) 2008  Alessandro Accattini


 *****************************************************************************
 *
 *
 *
 */

#ifndef __OLEDF_H_
#define __OLEDF_H_	1


#include <asm/semaphore.h>			// semaphores


/***************************************************************************/
/* define pubblici */

#define BUFFER_SIZE		64*128		// dimensione frame buffer

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* variabili pubbliche */

extern struct semaphore	HardSem;		// hardware access semaphore
extern unsigned char	DataBuffer[BUFFER_SIZE];	// frame buffer

/***************************************************************************/
/* funzioni pubbliche */

void OledInitDisplay(void);
  /* Inizializza il display driver. */

void OledDeinitDisplay(void);
  /* Elimina le risorse allocate dal display driver. */

void OledSendCommand(unsigned char *Cmd,unsigned long int CmdLen);
  /* Invia un array di command bytes al display driver. */

void OledSendData(unsigned char *Data,unsigned long int DataLen);
  /* Invia un array di data bytes al display driver. */

void OledRefreshImg(void);
  /* Copia l'intero frame buffer sul diplay. */

void OledPrintStr(char *Str,unsigned long int StrLen);
  /* Stampa una stringa a video come se fosse un display alfanumerico. */

void OledTurnOnDisplay(void);
  /* Abilita l'immagine sul display e riavvia il timer per lo spegnimento. */

void OledTurnOffDisplay(void);
  /* Spegne il display e distrugge il timer per lo spegnimento. */

/***************************************************************************/
#endif

/* $Source: /users/CVS/oled_linux/oledf.h,v $ */

